/* Copyright (C) 1991, 92, 93, 94, 95, 97, 2008 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#include <setjmp.h>
#include <stdlib.h>

/* Jump to the position specified by ENV, causing the
   setjmp call there to return VAL, or 1 if VAL is 0.  */
void
__longjmp (__jmp_buf env, int val)
{
  if (val == 0)
    val = 1;
  __asm__ volatile ("mov r2, %0" : : "r" (val));
  __asm__ volatile ("ldw r16, %0" : : "m" (env[0].__regs[0]));
  __asm__ volatile ("ldw r17, %0" : : "m" (env[0].__regs[1]));
  __asm__ volatile ("ldw r18, %0" : : "m" (env[0].__regs[2]));
  __asm__ volatile ("ldw r19, %0" : : "m" (env[0].__regs[3]));
  __asm__ volatile ("ldw r20, %0" : : "m" (env[0].__regs[4]));
  __asm__ volatile ("ldw r21, %0" : : "m" (env[0].__regs[5]));
  __asm__ volatile ("ldw r22, %0" : : "m" (env[0].__regs[6]));
  __asm__ volatile ("ldw r23, %0" : : "m" (env[0].__regs[7]));
  __asm__ volatile ("ldw sp, %0" : : "m" (env[0].__regs[8]));
  __asm__ volatile ("ldw fp, %0" : : "m" (env[0].__regs[9]));
  __asm__ volatile ("ldw ra, %0" : : "m" (env[0].__regs[10]));
}
